<template>
  <div class="app-button-toggle">
    <input
      id="toggle-on"
      class="toggle"
      name="toggle"
      :value="leftValue"
      type="radio"
      :checked="leftValue === value"
      @input="onInput"
    />
    <label for="toggle-on" class="label label--left">
      <i v-if="leftIcon" :class="['icon', leftIcon]"></i>
      {{ leftLabel }}
    </label>
    <input
      id="toggle-off"
      class="toggle"
      name="toggle"
      :value="rightValue"
      type="radio"
      :checked="rightValue === value"
      @input="onInput"
    />
    <label for="toggle-off" class="label label--right">
      <i v-if="rightIcon" :class="['icon', rightIcon]"></i>
      {{ rightLabel }}
    </label>
  </div>
</template>

<script>
export default {
  name: "appButtonToggle",

  props: {
    value: {
      type: String,
    },

    leftValue: {
      type: [String, Boolean],
      required: true
    },

    rightValue: {
      type: [String, Boolean],
      required: true
    },

    leftLabel: {
      type: String,
      required: true
    },

    rightLabel: {
      type: String,
      required: true
    },

    leftIcon: {
      type: String
    },

    rightIcon: {
      type: String
    }
  },

  methods: {
    onInput(e) {
      this.$emit('input', e.target.value)
    }
  },
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.app-button-toggle {
  display: flex;
  width: 200px;
  height: 24px;
  border-radius: 3px;
  z-index: 1;
}

.label {
  position: relative;
  width: 100px;
  display: flex;
  justify-content: center;
  align-items: center;
  @include font-mixin(11px, 1, 400, $blue-700, 0.4, uppercase);
  border-top: 1px solid $color-grey-border;
  border-bottom: 1px solid $color-grey-border;
  cursor: pointer;

  &:after{
      content: "";
      background-color: $blue-700;
      height: 100%;
      position: absolute;
      top: 0;
      transition: left 200ms cubic-bezier(0.77, 0, 0.175, 1);
      width: 100%;
      z-index: -1;
      box-shadow: inset 0px 2px 3px rgba(0, 0, 0, 0.4);
  }

  &--left {
    border-left: 1px solid $color-grey-border;
    border-top-left-radius: 3px;
    border-bottom-left-radius: 3px;

    &:after {
      left: 100%;
    }
  }

  &--right {
    border-right: 1px solid $color-grey-border;
    border-top-right-radius: 3px;
    border-bottom-right-radius: 3px;

    &:after {
      left: -100%;
    }
  }

  i {
    margin-right: 8px;
    font-size: 14px;
  }
}

.toggle {
  display: none;

  &:checked + .label {
    color: #fff;
    transition: color 200ms;

    &:after {
      left: 0;;
    }
  }
}
</style>
